/* The canonical cubicle numbers are:

   uf ul ub ur      0  1  2  3
   fr fl bl br      4  5  6  7
   df dl db dr      8  9 10 11
   urf ulf ulb urb 12 13 14 15
   drf dlf dlb drb 16 17 18 19
*/

char *name[20] =
  { "uf", "ul", "ub", "ur",
    "fr", "fl", "bl", "br",
    "df", "dl", "db", "dr",
    "urf", "ulf", "ulb", "urb",
    "drf", "dlf", "dlb", "drb"
  };

/* Define the identity operator */
struct operator I =
  { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19},
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0}
  };
  
/* Define the 6 face operators */
struct operator U =
  { { 1, 2, 3, 0, 4, 5, 6, 7, 8, 9, 10, 11, 13, 14, 15, 12, 16, 17, 18, 19 },
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 }
  };

struct operator D =
  { { 0, 1, 2, 3, 4, 5, 6, 7, 11, 8, 9, 10, 12, 13, 14, 15, 19, 16, 17, 18 },
    { 0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0 }
  };

struct operator L =
  { { 0, 5, 2, 3, 4, 9, 1, 7, 8, 6, 10, 11, 12, 17, 13, 15, 16, 18, 14, 19},
    { 0, 1, 0, 0, 0, 1, 1, 0, 0, 1,  0,  0,  0,  2,  1,  0,  0,  1,  2,  0} 
  };

struct operator R =
  { { 0, 1, 2, 7, 3, 5, 6, 11, 8, 9, 10, 4, 15, 13, 14, 19, 12, 17, 18, 16},
    { 0, 0, 0, 1, 1, 0, 0,  1, 0, 0,  0, 1,  1,  0,  0,  2,  2,  0,  0,  1}
  };

struct operator F =
  { { 4, 1, 2, 3, 8, 0, 6, 7, 5, 9, 10, 11, 16, 12, 14, 15, 17, 13, 18, 19},
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  2,  1,  0,  0,  1,  2,  0,  0}
  };

struct operator B =
  { { 0, 1, 6, 3, 4, 5, 10, 2, 8, 9, 7, 11, 12, 13, 18, 14, 16, 17, 19, 15},
    { 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0,  0,  0,  0,  2,  1,  0,  0,  1,  2}
  };
